
#include "StdAfx.h"
#include "CADOCE.h"


CADOCE::CADOCE(void)
{
	m_adoceCon	 = NULL;
	m_adoceRec	 = NULL;
	m_adoceFields = NULL;
	m_adoceField  = NULL;

	BOOL bRes;	


	bRes = SQLInit();
	if(bRes == FALSE) 
	{
		MessageBox(NULL, L"ʱȭ ", L"", MB_OK);
	}
}

CADOCE::~CADOCE(void)
{
	SQLClose();
	
	SQLUnInit();
}



BOOL CADOCE::SQLInit()
{
	HRESULT hr;

	hr = CoInitializeEx(NULL, COINIT_MULTITHREADED);
	if(FAILED(hr)) return FALSE;

	return TRUE;
}

BOOL CADOCE::SQLConnection(BSTR bstrCon)
{
	HRESULT hr;

	hr = CoCreateInstance(	CLSID_ADOCEConnection, 
							NULL, 
							CLSCTX_INPROC_SERVER, 
							IID_IADOCEConnection, 
							(LPVOID*) &m_adoceCon);
	if(FAILED(hr))	return FALSE;
	if(!m_adoceCon)	return FALSE;

	hr = m_adoceCon->Open(	bstrCon, 
							NULL, 
							NULL,
							adOpenUnspecified);
	if(FAILED(hr)) return FALSE;

	return TRUE;
}

BOOL CADOCE::SQLExecute(BSTR bstrCmd)
{
	HRESULT hr;

	hr = m_adoceCon->Execute(bstrCmd, NULL,adCmdText, &m_adoceRec);
	if(FAILED(hr))		return FALSE;
	if(!m_adoceRec)		return FALSE;

	return TRUE;
}

IADOCEFields* CADOCE::GetFields()
{
	m_adoceRec->get_Fields(&m_adoceFields);
	return m_adoceFields;
}

IADOCEField* CADOCE::GetField(int iField)
{
	GetFields()->get_Item(_variant_t((long)iField), &m_adoceField);
	return m_adoceField;
}

LONG CADOCE::GetFieldCount()	
{
	LONG lFieldCount;
	GetFields()->get_Count(&lFieldCount);
	return lFieldCount; 
}

LPCWSTR CADOCE::GetFieldName(int iField)
{
	IADOCEField * pField = GetField(iField);

	if(!pField)
	{
		return NULL;
	}

	BSTR	strFieldName;

	pField->get_Name(&strFieldName);

	return strFieldName;
}

VARIANT CADOCE::GetFieldValue(int iField)
{
	VARIANT value;

	VariantInit(&value);

	IADOCEField * pField = GetField(iField);

	if(!pField)
	{
		return _variant_t((long)0);
	}

	pField->get_Value(&value);
	return value;
}

LPCWSTR CADOCE::GetFieldValueString(int iField)
{
	VARIANT value = GetFieldValue(iField);
	VARIANT valueString;

	VariantInit(&valueString);

	if(value.vt == VT_BSTR)
	{
		valueString = value;
	}
	else
	{
		VariantChangeType(&valueString, &value, 0, VT_BSTR);
	}
	return valueString.bstrVal;
}

BOOL CADOCE::MoveFirst()
{
	if(!m_adoceRec)
	{
		return FALSE;
	}

	HRESULT hr = m_adoceRec->MoveFirst();

	return (!FAILED(hr));
}

BOOL CADOCE::MoveNext()
{
	if(!m_adoceRec)
	{
		return FALSE;
	}

	HRESULT hr = m_adoceRec->MoveNext();

	return (!FAILED(hr));
}

BOOL CADOCE::IsEOF()
{
	if(!m_adoceRec)
	{
		return FALSE;
	}

	VARIANT_BOOL	fValue;
	HRESULT			hr = m_adoceRec->get_EOF(&fValue);

	return (fValue == VARIANT_TRUE);
}

void CADOCE::SQLClose()
{
	if(m_adoceCon)
	{
		m_adoceCon->Release();
		m_adoceCon->Close();
		m_adoceCon = NULL;
	}
	if(m_adoceRec)
	{
		m_adoceRec->Release();
		m_adoceRec->Close();
		m_adoceRec = NULL;
	}
}

void CADOCE::SQLUnInit()
{
	CoUninitialize();
}
